﻿//
//
// Namespace
var ClickView = ClickView || {};

//
//
// Initialise Plugin
ClickView.Firefly = (function (ClickView, $) {
	var
		_xml = '',
		
		validate = function() {
			var valid = (_xml != '') || (loadModify() != '');
			
			if(!valid)
				notreadyReason = 'You must select a video to embed.';

			return valid;
		},

		// Poor man's templating
		template = function (str, o) {
			return str.replace(/{([^{}]*)}/g,
				function (a, b) {
					var r = o[b];
					return typeof r === 'string' || typeof r === 'number' ? r : a;
				}
			);
		},

		loadModify = function() {
			var autoPlayEl  = xBrowserGetElement("cv-autoplay"),
				shortCodeEl = xBrowserGetElement("cv-shortcode");

			if(!autoPlayEl || !shortCodeEl)
				return false;

			var data = {
				autoplay: autoPlayEl.checked.toString(),
				shortcode: shortCodeEl.value
			};

			var xml = compileXml(data);

			if (xml) {
				_xml = xml;
				return true;
			}

			return false;
		},

		encode = function() {
			return _xml;
		},

		focus = function () {},
		
		getXml = function() {
			return [
				'<clickview>',
					'<shortcode>{shortcode}</shortcode>',
					'<autoplay>{autoplay}</autoplay>',
				'</clickview>'
			].join("");
		},
		
		compileXml = function(data) {
			return template(getXml(), data);
		},
		
		saveXml = function (d) {
			var data = {
				autoplay:  (!!d.embed.autoplay) ? 'true' : 'false',
				shortcode: d.shortCode,
			};
			_xml = compileXml(data);
		},

		init = function() {
			$(function () {
				var pluginFrame = document.getElementById('cv-plugin-iframe');

				if (!pluginFrame)
					return;

				var eventsApi = new CVEventsApi(pluginFrame.contentWindow);
				eventsApi.on('cv-lms-addvideo', function (event, details) {
					saveXml(details);
				});
			});
		};

	init();
	
	return {
		Focus:    focus,
		Encode:   encode,
		Validate: validate
	};
}(ClickView, jQuery));
